<?php
namespace Fiscal\Logic\Sped;

use Geral\Util\TratamentoDeMensagens;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Indeterminado\Entities\Dadosgersped;
use \Geral\Entities\Arqmagnetico;
use Symfony\Component\Validator\Constraints\True;

class SpedFiscal{

    public static function ExportSped($cdimposto,$cdempresa,$cdinscesta,$dtrefini,$dtreffim,$nrorg,$nmarquivo,$cdlivromag,$idgerablocoh,$dtiniperfisc,$dtfinperfisc,$cdmotinventario){
        try {

            if ($cdimposto == null){
                tk_abort('Imposto deve ser informado.');
            }
            elseif ($cdempresa == null){
                tk_abort('Empresa deve ser informada.');
            }
            elseif ($cdinscesta == null){
                tk_abort('Inscrição deve ser informada.');
            }
            elseif ($cdlivromag == null){
                tk_abort('Livro Magnético deve ser informado.');
            }
            elseif ($dtrefini == null){
                tk_abort('Data Inicial deve ser informada.');
            }
            elseif ($dtreffim == null){
                tk_abort('Data Final deve ser informada.');
            }
            elseif ($dtrefini > $dtrefini){
                tk_abort('Data Final deve ser maior que data inicial.');
            }
            elseif ($nmarquivo == null){
                tk_abort('Nome do arquivo deve ser informado.');
            }
            elseif (($idgerablocoh == 'S') and ($dtiniperfisc == null)){
                tk_abort('Data Inicial Inv. deve ser informada.');
            }
            elseif (($idgerablocoh == 'S') and ($dtfinperfisc == null)){
                tk_abort('Data Final Inv. deve ser informada.');
            }
            elseif (($idgerablocoh == 'S') and ($cdmotinventario == null)){
                tk_abort('Motivo do Inventário deve ser informado.');
            }
            else {
                //TK_VAR_DUMP($dadosgersped->getCdversao());
                /** @var $dadosgersped \Indeterminado\Entities\Dadosgersped */
                $dadosgersped = \Indeterminado\Entities\Dadosgersped::findOneByCdempresaAndCdinscestaAndNrorg($cdempresa, $cdinscesta, $nrorg);

                if ($dadosgersped == null) {
                    tk_abort('Parâmetros deve ser informado.');
                    self::insert_dadosgersped($cdempresa, $cdinscesta, $nrorg);
                   // tk_open_window('win_pbi00145_000_01');
                    $dadosgersped = \Indeterminado\Entities\Dadosgersped::findOneByCdempresaAndCdinscestaAndNrorg($cdempresa, $cdinscesta, $nrorg);
                }

                if ($dadosgersped->getCdversao() == null) {
                    tk_abort('Parâmetros deve ser informado.');
                  //  tk_open_window('win_pbi00145_000_01');
                }
                else {
                    /** @var $nrseqarqmag \Fiscal\Repositories\Arqmagpiscofins */
                    $nrseqarqmag = \Geral\Repositories\Arqmagnetico::MaiorCod($nrorg);
                    $nrseqarqmag += 1;

                    $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
                    $connection->beginTransaction();

                    for ($i = 0; $i < 1; $i++) {
                        $procedure = new Procedure('ARQUIVO_SPED');
                        $procedure->addParam(new Param('P_CDIMPOSTO', Param::PARAM_INPUT, $cdimposto, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $cdempresa, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_CDINSCESTA', Param::PARAM_INPUT, $cdinscesta, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $dtrefini, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $dtreffim, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_CDLIVROMAG', Param::PARAM_INPUT, $cdlivromag, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_TIPO', Param::PARAM_INPUT, '', Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_FINALIDADE', Param::PARAM_INPUT, $dadosgersped->getIdfinarquivo(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_INDESCRITU', Param::PARAM_INPUT, '', Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_PERFIL', Param::PARAM_INPUT, $dadosgersped->getIdperaprestaco(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_ATIVIDADE', Param::PARAM_INPUT, $dadosgersped->getIdindatividade(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_VERSAO', Param::PARAM_INPUT, $dadosgersped->getCdversao(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_NRSEQARQMAG', Param::PARAM_INPUT, $nrseqarqmag, Param::PARAM_TYPE_STR)); /*P_NRSEQARQMAG  select+1*/
                        $procedure->addParam(new Param('P_BLOCOH', Param::PARAM_INPUT, $idgerablocoh, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_DTINIPER', Param::PARAM_INPUT, $dtiniperfisc, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_DTFINPER', Param::PARAM_INPUT, $dtfinperfisc, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_IDDIFALIQ', Param::PARAM_INPUT, $dadosgersped->getIdgerdifaliq(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_GERAFORSALE', Param::PARAM_INPUT, 'N', Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_MOTINV', Param::PARAM_INPUT, $cdmotinventario, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_OBRIGREGBL1', Param::PARAM_INPUT, $dadosgersped->getCdobrigaregbl1(), Param::PARAM_TYPE_STR));
                        $procedure->call();
                    }
                    if ($i == 0) {
                        $exeproc = false;
                        $connection->rollBack();
                    } elseif ($i == 1) {
                        $exeproc = true;
                        $connection->commit();
                    }

                    /*
                    fopen abre o arquivo no modo de escrita, depois cria-se uma conexão com o banco,
                    executa-se a busca na tabela 'temporaria' onde estão as informações e o foreach serve para
                    percorrer todas as linhas na qual o select retorna e montar o arquivo txt.
                    Após o foreach fecha-se e salva o arquivo com o fclose.
                    Por fim limpa-se a tabela 'temporaria'.
                    */
                    /** @var $nrseqarqmag \Fiscal\Repositories\Arqmagpiscofins */
                    if ($exeproc) {
                        $nrseqarqmag = \Geral\Repositories\Arqmagnetico::MaiorCod($nrorg);

                        $caminho = APP_PATH . "/public/Fiscal/$nrorg/";
                        if (!is_dir($caminho)) {
                            mkdir($caminho, "0777", true);
                        }

                        $file = fopen("$caminho$nmarquivo.txt", "w");

                        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
                        $stmt = $connection->prepare("SELECT T.DSREGARQMAG
                                               FROM
                                                   (SELECT DSREGARQMAG, ROWNUM AS SEQUENCIAL
                                                      FROM
                                                          (SELECT NRORDREGARQ,DSREGARQMAG
                                                             FROM ARQMAGNETICO
                                                            WHERE NRSEQARQMAG = '$nrseqarqmag'
                                                              AND NRORG = '$nrorg'
                                                            ORDER BY NRORDREGARQ))T
                                            ");
                        $stmt->execute();
                        $value = $stmt->fetchAll(\PDO::FETCH_ASSOC);
                        foreach ($value as $linha) {
                            fprintf($file, "%s", iconv('UTF-8', "ASCII//TRANSLIT", $linha['DSREGARQMAG'] . "\r\n")); //iconv serve para converter o arquivo txt para a codificação ANSI
                        }
                        fclose($file);
                        $url = realpath($caminho . $nmarquivo . '.txt');

                        $arquivo = new \TkFile($url);
                        $arquivo->download();

                        tk_message('Operação realizada com sucesso!', 'success');
                        \Geral\Repositories\Arqmagnetico::LimpaTabela($nrorg, $nrseqarqmag);
                    }
                }
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function insert_dadosgersped($cdempresa,$cdinscesta,$nrorg){
        try {
            $data = \Geral\Util\DateUtil::getDataAtual();
            $cdoperador = \Geral\Util\Ambiente::getCdOperador();
            $dadosgersped = new Dadosgersped();
            $dadosgersped->setCdempresa($cdempresa);
            $dadosgersped->setCdinscesta($cdinscesta);
            $dadosgersped->setIdfinarquivo('0');
            $dadosgersped->setIdperaprestaco('A');
            $dadosgersped->setIdindatividade('1');
            $dadosgersped->setIdgerdifaliq('N');
            $dadosgersped->setCdobrigaregbl1('NNNNNNNNN');
            $dadosgersped->setNrorg($nrorg);
            $dadosgersped->setDtinclusao($data);
            $dadosgersped->setDtultatu($data);
            $dadosgersped->setCdoperinclusao($cdoperador);
            $dadosgersped->setCdoperultatu($cdoperador);
            $dadosgersped->persist(); //pre commit
            \Setforms2\Shared\Registry::getEntityManager()->flush(); //Commit
        } catch (\Exception $e) {
            throw $e;
        }

    }

}